package com.community.pocket.ui.main.ui.visitor.reservation;

import androidx.annotation.StringRes;

import com.community.pocket.R;
import com.community.pocket.data.model.VisitorReservation;
import com.community.pocket.ui.main.ui.share.Response;
import com.community.pocket.util.CustomMessage;

import org.jetbrains.annotations.NotNull;

import java.util.List;

/**
 * 我的预约信息
 */
public class VisitorReservationResponse extends Response<VisitorReservationResponse.Msg> {
    private List<VisitorReservation> visitorList;

    List<VisitorReservation> getVisitorList() {
        return visitorList;
    }

    public void setVisitorList(List<VisitorReservation> visitorList) {
        this.visitorList = visitorList;
    }

    enum Msg implements CustomMessage {
        ok(R.string.load_visitor_reservation_ok),
        fail(R.string.load_visitor_reservation_fail),
        token(R.string.invalid_token);

        private Integer msg;

        Msg(@StringRes Integer msg) {
            this.msg = msg;
        }

        @NotNull
        @Override
        public Integer getMsg() {
            return msg;
        }
    }
}
